## org.hibernate.criterion
Class AggregateProjection

    java.lang.Object
      org.hibernate.criterion.SimpleProjection
          org.hibernate.criterion.AggregateProjection

All Implemented Interfaces:
  Serializable, EnhancedProjection, Projection

Direct Known Subclasses:
  AvgProjection, CountProjection

    public class AggregateProjection

extends SimpleProjection

Base class for standard aggregation functions.

Author:
  max
See Also:
  Serialized Form

Field Summary
`protected String` `propertyName`

Constructor Summary
`protected` `AggregateProjection(String functionName, String propertyName)`

Method Summary
`protected List` `buildFunctionParameterList(Criteria criteria, CriteriaQuery criteriaQuery)`
`protected List` `buildFunctionParameterList(String column)`
`protected SQLFunction` `getFunction(CriteriaQuery criteriaQuery)`
`protected SQLFunction` `getFunction(String functionName, CriteriaQuery criteriaQuery)`
`String` `getFunctionName()`
`String` `getPropertyName()`
`Type[]` `getTypes(Criteria criteria, CriteriaQuery criteriaQuery)` Types returned by the rendered SQL `fragment`.
`String` `toSqlString(Criteria criteria, int loc, CriteriaQuery criteriaQuery)` Render the SQL fragment to be used in the `SELECT` clause.
`String` `toString()`

Methods inherited from class org.hibernate.criterion.SimpleProjection
`as, getAliases, getColumnAliases, getColumnAliases, getColumnAliases, getColumnAliases, getColumnCount, getTypes, isGrouped, toGroupSqlString`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Field Detail

### propertyName

    protected final String propertyName

Constructor Detail

### AggregateProjection

    protected AggregateProjection(String functionName,
                                  String propertyName)

Method Detail

### getFunctionName

    public String getFunctionName()

### getPropertyName

    public String getPropertyName()

### toString

    public String toString()

  Overrides:
    `toString` in class `Object`

### getTypes

    public Type[] getTypes(Criteria criteria,
                           CriteriaQuery criteriaQuery)
                    throws HibernateException

  Types returned by the rendered SQL `fragment`. In other words what are the types that would represent the values this projection asked to be pulled into the result set?

  Parameters:
    `criteria` - The local criteria to which this project is attached (for resolution).
    `criteriaQuery` - The overall criteria query instance.
  Returns:
    The return types.
  Throws:
    `HibernateException` - Indicates a problem resolving the types

### toSqlString

    public String toSqlString(Criteria criteria,
                              int loc,
                              CriteriaQuery criteriaQuery)
                       throws HibernateException

  Render the SQL fragment to be used in the `SELECT` clause.

  Parameters:
    `criteria` - The local criteria to which this project is attached (for resolution).
    `loc` - The number of columns rendered in the `SELECT` clause before this projection. Generally speaking this is useful to ensure uniqueness of the individual columns aliases.
    `criteriaQuery` - The overall criteria query instance.
  Returns:
    The SQL fragment to plug into the `SELECT`
  Throws:
    `HibernateException` - Indicates a problem performing the rendering

### getFunction

    protected SQLFunction getFunction(CriteriaQuery criteriaQuery)

### getFunction

    protected SQLFunction getFunction(String functionName,
                                      CriteriaQuery criteriaQuery)

### buildFunctionParameterList

    protected List buildFunctionParameterList(Criteria criteria,
                                              CriteriaQuery criteriaQuery)

### buildFunctionParameterList

    protected List buildFunctionParameterList(String column)

Copyright © 2001-2010 Red Hat, Inc. All Rights Reserved.